
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Lua语法基础(3)--迭代器和泛型for / 憋错料</title>

    <meta name="description" content="Lua语法基础(3)--迭代器和泛型for 迭代器和闭包 迭代器是一种支持指针类型的结构,它可以遍历集合的每一个元素.在Lua中我们常常使用函数来描述迭代器,每次调用该函数就返回集合的下一个元素. 迭代器需要保留上一次成功调用的状态和下一次成功调用的状态,也就是他知道来自于哪里和将要前往哪里.闭包提供的机制可以很容易实现这个任务.记住:闭包是一个内部函数,它可以访问一个或者多个外部函数的外部局部变量.每次闭包的成功调用后这些外部局部变量都保存他们的值(状态).当然如果要创建一个闭包必须要创建其外部局部变量.所以一个典型的闭包的结构包含两个">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Lua语法基础(3)--迭代器和泛型for</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>迭代器和闭包</strong></p>
<p>迭代器是一种支持指针类型的结构，它可以遍历集合的每一个元素。在Lua中我们常常使用函数来描述迭代器，每次调用该函数就返回集合的下一个元素。</p>
<p>迭代器需要保留上一次成功调用的状态和下一次成功调用的状态，也就是他知道来自于哪里和将要前往哪里。闭包提供的机制可以很容易实现这个任务。记住：闭包是一个内部函数，它可以访问一个或者多个外部函数的外部局部变量。每次闭包的成功调用后这些外部局部变量都保存他们的值（状态）。当然如果要创建一个闭包必须要创建其外部局部变量。所以一个典型的闭包的结构包含两个函数：一个是闭包自己；另一个是工厂（创建闭包的函数）。</p>
<p>举一个简单的例子，我们为一个list写一个简单的迭代器，与ipairs()不同的是我们实现的这个迭代器返回元素的值而不是索引下标：</p>
<pre>function list_iter (t)

　　local i = 0
　　local n = table.getn(t)
　　return function ()
　　　　i = i + 1
　　　　if i &lt;= n then return t[i] end　　end
end</pre>
<p>这个例子中list_iter是一个工厂，每次调用他都会创建一个新的闭包（迭代器本身）。闭包保存内部局部变量(t,i,n)，因此每次调用他返回list中的下一个元素值，当list中没有值时，返回nil.我们可以在while语句中使用这个迭代器：</p>
<pre>t = {10, 20, 30}
iter = list_iter(t) -- creates the iterator
while true do
　　local element = iter() -- calls the iterator
　　if element == nil then break end
　　print(element)
end</pre>
<p>我们设计的这个迭代器也很容易用于范性for语句。</p>
<pre>t = {10, 20, 30}
for element in list_iter(t) do
　　print(element)
end</pre>
<p>范性for为迭代循环处理所有的薄记（bookkeeping）：首先调用迭代工厂；内部保留迭代函数，因此我们不需要iter变量；然后在每一个新的迭代处调用迭代器函数；当迭代器返回nil时循环结束。</p>
<p><strong>范性for</strong><strong>的语义</strong></p>
<p>前面我们看到的迭代器有一个缺点：每次调用都需要创建一个闭包，大多数情况下这种做法都没什么问题，然而在有些情况下创建闭包的代价是不能忍受的。在这些情况下我们可以使用范性for本身来保存迭代的状态。</p>
<p>前面我们看到在循环过程中范性for在自己内部保存迭代函数，实际上它保存三个值:迭代函数，状态常量和控制变量.下面详细说明。</p>
<p>范性for的文法如下：</p>
<pre>for &lt;var-list&gt; in &lt;exp-list&gt; do
　　&lt;body&gt;
End</pre>
<p>&lt;var-list&gt;是一个或多个以逗号分割的变量名列表，&lt;exp-list&gt;是一个或多个以逗号分割的表达式列表，通常情况下exp-list只有一个值：迭代工厂的调用。</p>
<pre>for k, v in pairs(t) do
　　print(k, v)
end</pre>
<p>变量列表k,v；表达式列表pair(t)。</p>
<p>我们称变量列表中第一个变量为控制变量，其值为nil时循环结束。</p>
<p>下面我们看看范性for的执行过程：</p>
<p>首先，初始化，计算in后面表达式的值，表达式应该返回范性for需要的三个值：迭代函数，状态常量和控制变量；与多值赋值一样，如果表达式返回的结果个数不足三个会自动用nil补足，多出部分会被忽略。</p>
<p>第二，将状态常量和控制变量作为参数调用迭代函数（注意：对于for结构来说，状态常量没有用处，仅仅在初始化时获取他的值并传递给迭代函数）。</p>
<p>第三，将迭代函数返回的值赋给变量列表。</p>
<p>第四，如果返回的第一个值为nil循环结束，否则执行循环体。</p>
<p>第五，回到第二步再次调用迭代函数。</p>
<p>更精确的来说：</p>
<pre>for var_1, ..., var_n in explist do block end</pre>
<p>等价于：</p>
<pre>do
local _f, _s, _var = explist
while true do
　　local var_1, ... , var_n = _f(_s, _var)
　　_var = var_1
　　if _var == nil then break end
　　　　block
　　end
end</pre>
<p>如果我们的迭代函数是f，状态常量是s，控制变量的初始值是a0，那么控制变量将循环：a1=f(s,a0)、a2=f(s,a1)、??，直到ai=nil。</p>
<p><strong>无状态的迭代器</strong></p>
<p>每一次迭代，迭代函数都是用两个变量（状态常量和控制变量）的值作为参数被调用，一个无状态的迭代器只利用这两个值可以获取下一个元素。这种无状态迭代器的典型的简单的例子是ipairs，他遍历数组的每一个元素。</p>
<pre>a = {"one", "two", "three"}
for i, v in ipairs(a) do
    print(i, v)
end</pre>
<p>迭代的状态包括被遍历的表（循环过程中不会改变的状态常量）和当前的索引下标（控制变量），ipairs和迭代函数都很简单，我们在Lua中可以这样实现：</p>
<pre>function iter (a, i)
    i = i + 1
    local v = a[i]
    if v then
        return i, v
    end
end

function ipairs (a)
    return iter, a, 0
end     </pre>
<p>当Lua 调用 ipairs(a)开始循环时，他获取三个值:迭代函数 iter，状态常量 a 和控制变量初始值0；然后Lua调用iter(a,0)返回1,a[1]（除非a[1]=nil）；第二次迭代调用iter(a,1)返回2,a[2]??直到第一个非nil元素。</p>
<p><strong>多状态的迭代器</strong></p>
<p>很多情况下，迭代器需要保存多个状态信息而不是简单的状态常量和控制变量，最简单的方法是使用闭包，还有一种方法就是将所有的状态信息封装到table内，将table作为迭代器的状态常量，因为这种情况下可以将所有的信息存放在table内，所以迭代函数通常不需要第二个参数。</p>
<p>下面我们写allwords迭代器，不适用闭包，而是使用带有两个域（line,pos）的table。</p>
<p>开始的迭代函数很简单，必须返回迭代函数和初始状态。</p>
<pre>local iterator -- to be defined later
function allwords()local state = {line = io.read(), pos = 1}
    return iterator, state
end</pre>
<p>真正的处理工作是在迭代函数内完成：</p>
<pre>function iterator (state)
　　while state.line do  --repeat while there are lines
　　--search for next word
　　local s,e = string.find(state.line,&rdquo;%w+&rdquo;,state.pos)
　　　　if s then
　　　　　　state.pos = e+1
　　　　　　return string.sub(state.line,s,e)
　　　　else
　　　　　　state.line = io.read()
　　　　　　state.pos = 1
　　　　end
　　end
　　return nil
end</pre>
<p>我们应该尽可能的写无状态的迭代器，因为这样循环的时候由 for 来保存状态，如果不能用无状态的迭代器实现，应尽可能适用闭包；尽可能不要适用table这种方式。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 12:04:25 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Lua语法基础(3)--迭代器和泛型for的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEYQmXM.html" rel="bookmark">Lua脚本之语法基础快速入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				要 1.基本数据类型 2.Lua中的常用语句结构以及函数 3.Lua中的常用语句结构介绍 4.Lua中的库函数 目录[-] 一.基本数据类型 二.Lua中的常用语句结构以及函数 1.Lua中的常用语句结构介绍 三.Lua中的库函数 Lua的语法基础超级简单,非常易于上手,下面总结一些学习过程中的Lua语法基础: 在开始学习之前,先介绍一些最基本的概念,在Lua中具有一个代码块的概念,每个函数或者for循环等都是一个代码块.在Lua中,用 “- - ”来标记该行的注释,使用“- - [ [” 和			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35AWbR3.html" rel="bookmark">Lua语言基础汇总（6）-- 迭代器与泛型for</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 迭代器就是一种可以遍历一种集合中所有元素的机制,在Lua中,通常将迭代器表示为函数.每调用一次函数,就返回集合中的“下一个”元素.每个迭代器都需要在每次成功调用之后保存一些状态,这样才能知道它所在的位置及如何走到下一个位置,通过之前博文的总结,闭包对于这样的任务提供了极佳的支持.现在我们就用代码来实现一个简单的迭代器. 1 2 3 4 5 6 7 8 9 10 11 12 function values(tb)      local i = 0      return function (			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RQzRpM.html" rel="bookmark">［转］Lua语言基础汇总（6）-- 迭代器与泛型for</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 迭代器就是一种可以遍历一种集合中所有元素的机制,在Lua中,通常将迭代器表示为函数.每调用一次函数,就返回集合中的“下一个”元素.每个迭代器都需要在每次成功调用之后保存一些状态,这样才能知道它所在的位置及如何走到下一个位置,通过之前博文的总结,闭包对于这样的任务提供了极佳的支持.现在我们就用代码来实现一个简单的迭代器. 1 2 3 4 5 6 7 8 9 10 11 12 function values(tb)      local i = 0      return function (			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/L3rB1v3.html" rel="bookmark">lua中的迭代器与泛型for</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				任何一种结构,只要允许你遍历集合中所有元素的都可称之为迭代器.lua中常常使用函数来描述迭代器,每次调用该函数都返回集合的下一个元素.每一个迭代器都需要保存一些状态来知道当前处于什么位置和如何进行下一次迭代.对于这样的任务,闭包提供了很好的机制来完成.一个典型的闭包结构包含两个函数:一个是闭包自身,一个是创建闭包的工厂. 例如,我们可以写过简单的list迭代器,让他仅仅返回值. function values( t ) local i = 0; return function() i = i +			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MznDVyM.html" rel="bookmark">二、Lua迭代器与泛型for</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				注:本文转自Stephen_Liu的文章:Step By Step(Lua迭代器和泛型for).http://www.cnblogs.com/stephen-liu74/archive/2012/06/20/2413799.html 1. 迭代器与Closure:    在Lua中,迭代器通常为函数,每调用一次函数,即返回集合中的“下一个”元素.每个迭代器都需要在每次成功调用之间保持一些状态,这样才能知道它所在的位置和下一次遍历时的位置.从这一点看,Lua中closure机制为此问题提供了语言上			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vKbka4.html" rel="bookmark">Lua学习笔记&lpar;七&rpar;：迭代器与泛型for</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.迭代器与闭包 迭代器是一种支持指针类型的结构,它可以遍历集合的每一个元素.在Lua中我们常常使用函数来描述迭代器,每次调用该函数就返回集合的下一个元素. 迭代器需要保留上一次成功调用的状态和下一次成功调用的状态,也就是他知道来自于哪里和将要前往哪里.闭包提供的机制可以很容易实现这个任务.记住:闭包是一个内部函数,它可以访问一个或者多个外部函数的外部局部变量.每次闭包的成功调用后这些外部局部变量都保存他们的值(状态).当然如果要创建一个闭包必须要创建其外部局部变量.所以一个典型的闭包的结构包含			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dnzRz4.html" rel="bookmark">lua学习之迭代器与泛型for第一篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				迭代器与泛型 for 1 迭代器与 closure 「迭代器」是一种可以遍历一种集合中的所有元素的机制 在 lua 中通常将迭代器表示为函数 每调用一次函数,即返回集合中的「下一个」元素 每个迭代器都需要在每次成功调用之间保存一些状态 这样就知道它现在所在的位置以及如何步进到一下位置 一个 closure 就是一种可以访问其外部嵌套环境中的局部变量的函数 这些变量可用于在成功调用之间保持状态值 从而使 closure 可以记住它在一次遍历中所在的位置 创建一个 closure 必须创建它的「非局			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aY8wJ0.html" rel="bookmark">Lua语言基础汇总（3） -- 语句</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				赋值 赋值的基本含义是修改一个变量或一个table中字段的值,这个和其它语言没有多少区别,但是对于Lua,有一个特性,它允许“多重赋值”,也就是一下子将多个值赋予多个变量,例如以下代码: 1 2 3 local x1, x2 = 2, 4 print(x1)     --&gt;2 print(x2)     --&gt;4 在多重赋值中,Lua先对等号右边的所有元素求值,然后才执行赋值,例如以下用法,可以非常简便的交换两个元素的值: 1 2 3 4 local x1, x2 = 2, 4 x1, x2 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3q1avz3.html" rel="bookmark">［转］Lua语言基础汇总（3） -- 语句</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				赋值 赋值的基本含义是修改一个变量或一个table中字段的值,这个和其它语言没有多少区别,但是对于Lua,有一个特性,它允许“多重赋值”,也就是一下子将多个值赋予多个变量,例如以下代码: 1 2 3 local x1, x2 = 2, 4 print(x1)     --&gt;2 print(x2)     --&gt;4 在多重赋值中,Lua先对等号右边的所有元素求值,然后才执行赋值,例如以下用法,可以非常简便的交换两个元素的值: 1 2 3 4 local x1, x2 = 2, 4 x1, x2 			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/BMzky0k.html" rel="bookmark" class="title">centos7开机无法进入图形界面，出现sda assuming drive cache write through的一个解决方案</a>
					<div>
						centos7开机无法进入图形界面,出现sda assuming drive cache write through.no valid rapl domains found in package之类信 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q3qEyP3.html" rel="bookmark" class="title">devise登陆页不使用application模版</a>
					<div>
						class ApplicationController &lt; ActionController::Base   layout :layout   private   def layout      ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q3qWY5M.html" rel="bookmark" class="title">电话相亲之感</a>
					<div>
						三八妇女节,爸爸的一个朋友,热心给我介绍某工作男,暂且称为A.其实爸爸的这个朋友也是A的某个亲戚,所以相对来说,这件事要比普通相亲严肃些. A87年,本科毕业后在上海工作.除此信息外,其他的我一无所知 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eqqnv0.html" rel="bookmark" class="title">认识htnl最基本的几个标签</a>
					<div>
						在HTML里面,有许多的标签,但是别的标签出现是需要一定的的层次问题,但是任何的HTML网页,都会有的几对标签,相信大家都知道了,今天就来看看这几个吧! &lt;html&gt;-&lt;/html& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/My5KwEM.html" rel="bookmark" class="title">统计交易消耗的平均时间</a>
					<div>
						sample: 文件名trans [ae8a20df-444c-45cb-ad02-52491862d7d5][进程22028][2017-03-09][01:04:22]交易结束!返回处理结果发送给 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZYwGJ0.html" rel="bookmark" class="title">2&period;Scanner的应用</a>
					<div>
						import java.util.Scanner; public class TestScanner { public static void main(String[] args) { Scanne ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBAkXA4.html" rel="bookmark" class="title">循环经典--------冒泡排序，查找。</a>
					<div>
						1.冒泡排序 将8个整数进行升序排列 22 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 22 4 4 4 4 4 4 4 4 4 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyjlOL0.html" rel="bookmark" class="title">Android 进程生命周期 Process Lifecycle</a>
					<div>
						进程的生命周期 Android系统会尽力保持应用的进程,但是有时为了给新的进程和更重要的进程回收一些内存空间,它会移除一些旧的进程. 为了决定哪些进程留下,哪些进程被杀死,系统根据在进程中在运行的组件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38wpq20.html" rel="bookmark" class="title">PS图片</a>
					<div>
						第二次练习PS,不知道找什么图片,就这么做着吧.然后自己学习了下动画制作,但是中间有些问题,需要再研究研究. 像 CS6中新建蒙版文档,画出的图形单位是厘米,怎么改为像素?(答案看后续博客....)					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myl6Ya4.html" rel="bookmark" class="title">2017暑假集训~心路历程</a>
					<div>
						2017年暑假集训的个人赛阶段已经结束了. 回想这7场比赛,前几场发挥的还可以. 但是第4场之后开始状态开始下滑.第4场是在TOJ上做的,题数马马虎虎,就是罚时有点多. 第5场的FOJ的比赛打得十分糟 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41o1zo0.html" rel="bookmark" class="title">开始的一天</a>
					<div>
						今天又是一天,烦恼事情比较多的一天,随着生活的压力靠近,发现自己真的太渺小了,很多东西度不会,什么度不懂,感觉又懂那么一点,这是多么苦闷的事情,以前欢快无比的时候,再对比此时的苦恼焦耳,一字:&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGpNKV0.html" rel="bookmark" class="title">Cocos2d-x 3&period;2 大富翁游戏项目开发-第十六部分 相连地块缴纳过路费</a>
					<div>
						当走到其他角色的地块时,根据当前地块是否连片,连片的话统一计算需要缴纳的过路费,连片的计算方式,是各个地块过路费总和. 首先获取当前行走角色路过的地块的x y坐标(Land layer层的坐标),然后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NjORV4.html" rel="bookmark" class="title">一只老鼠夹</a>
					<div>
						这个故事最初是从领导那里听来的: 农场主在粮仓里放了个老鼠夹子. 老鼠发现了去告诉母鸡. 母鸡看了看老鼠说:“这和我有什么关系,你的事,自己小心吧”. 母鸡说完走了. 老鼠又跑去告诉肥猪. 肥猪淡淡的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXqkea0.html" rel="bookmark" class="title">排查Hive报错：org&period;apache&period;hadoop&period;hive&period;serde2&period;SerDeException&colon; java&period;io&period;IOException&colon; Start of Array expected</a>
					<div>
						CREATE TABLE json_nested_test ( count string, usage string, pkg map&lt;string,string&gt;, languages  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVvgQQM.html" rel="bookmark" class="title">C&num;获取外网IP、本机MAC地址及Ping的实现</a>
					<div>
						原文 获取外网IP, C#获取本机的MAC地址,C#通过编程方式实现Ping 获取外网IP地址 思路是通过WebRequest连接一些网上提供IP查询服务的网站,下载到含有你的IP的网页,然后用正则表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wBepY0.html" rel="bookmark" class="title">iOS开发基础-UIScrollView实现图片缩放</a>
					<div>
						当用户在 UIScrollView 上使用捏合手势时, UIScrollView 会给 UIScrollViewDelegate 协议发送一条消息,并调用代理的 viewForZoomingInScr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0neLyKM.html" rel="bookmark" class="title">&lbrack;NHibernate&rsqb;使用AttributeNHibernate&period;Mapping&period;Attributes</a>
					<div>
						系列文章 [Nhibernate]体系结构 [NHibernate]ISessionFactory配置 [NHibernate]持久化类(Persistent Classes) [NHibernate ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41yk9v4.html" rel="bookmark" class="title">HDU - 5096 ACM Rank  （Treap）</a>
					<div>
						平衡树的题,Treap破之,比较难搞的出现相同题数罚时的情况,解决方法是在每个结点用一个set,比较值的时候可以把题数和罚时保存到一起. 初始化有一定技巧.细节很多容易出错. 写错一个变量名字查好久, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyNY6L0.html" rel="bookmark" class="title">带参数setTimeout</a>
					<div>
						/*         功能:修改 window.setTimeout,使之可以传递参数和对象参数         使用方法: window.setTimeout(回调函数,时间,参数1,,参数n)   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l9alZ3.html" rel="bookmark" class="title">Ubuntu 14&period;04 配置 Java SE</a>
					<div>
						首先下载Java SE,下载地址:http://www.oracle.com/technetwork/java/javase/downloads/index.html: 下载后把压缩包拷贝到自定义的目 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.022 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
